<template>
  <div class="app-container">

    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">

      <el-form-item label="日期时间">
        <el-date-picker
          v-model="queryParams.beginCreateTime"
          type="date"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endCreateTime"
          type="date"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="用户来源">
        <el-select
          v-model="queryParams.source"
          class="filter-item"
          placeholder="用户来源"
          style="width: 140px"
          filterable
          clearable
          remote
          reserve-keyword
        >
          <el-option
            v-for="item in sourceData"
            :key="item.source"
            :label="item.name"
            :value="item.source"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">筛选</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
    </el-form>
    <el-table :data="tableData"  :summary-method="getSummaries" show-summary style="width:100%" class="show_table"  >
      <el-table-column label="日期" style="width:4%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.period }}</span>
        </template>
      </el-table-column>
      <el-table-column label="渠道" style="width:2%" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>

      <el-table-column label="日活(人)" style="width:30%" :show-overflow-tooltip="true" align="center" prop="onlineNum">
        <template slot-scope="scope">
          <span>{{ scope.row.onlineNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="新用户(人)" style="width:30%" :show-overflow-tooltip="true" align="center" prop="registerNum">
        <template slot-scope="scope">
          <span>{{ scope.row.registerNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="全部订单总数（笔）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="totalOrder">
        <template slot-scope="scope">
          <span>{{ scope.row.totalOrder }}</span>
        </template>
      </el-table-column>
      <el-table-column label="成功订单总数（笔）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="totalFinshOrder">
        <template slot-scope="scope">
          <span>{{ scope.row.totalFinshOrder }}</span>
        </template>
      </el-table-column>
      <el-table-column label="首存订单总数（笔）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="totalFirstDep">
        <template slot-scope="scope">
          <span>{{ scope.row.totalFirstDep }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员订单总数（笔）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="totalVipOrder">
        <template slot-scope="scope">
          <span>{{ scope.row.totalVipOrder }}</span>
        </template>
      </el-table-column>
      <el-table-column label="非会员订单总数（笔）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="totalEtcOrder">
        <template slot-scope="scope">
          <span>{{ scope.row.totalEtcOrder }}</span>
        </template>
      </el-table-column>
      <el-table-column label="总存款用户数" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="totalDepNum">
        <template slot-scope="scope">
          <span>{{ scope.row.totalDepNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="成功存款用户数" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="depNum">
        <template slot-scope="scope">
          <span>{{ scope.row.depNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="成功取款用户数" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="wdlNum">
        <template slot-scope="scope">
          <span>{{ scope.row.wdlNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="首存订单总金额（元）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="firstDepAmount">
        <template slot-scope="scope">
          <span>{{ scope.row.firstDepAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="成功订单总金额（元）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="finshOrderAmount">
        <template slot-scope="scope">
          <span>{{ scope.row.finshOrderAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="提现订单总金额（元）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="wdlAmount">
        <template slot-scope="scope">
          <span>{{ scope.row.wdlAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="提现订单总金额(已扣手续费)" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="wdlTaxAmount">
        <template slot-scope="scope">
          <span>{{ scope.row.wdlTaxAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="存取差（元）" style="width:2%"  :show-overflow-tooltip="true" align="center" prop="depWdlSub">
        <template slot-scope="scope">
          <span>{{ scope.row.depWdlSub }}</span>
        </template>
      </el-table-column>

    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import {getAppReportList,getSourceList} from "@/api/gameAppReport";
import {
  export_json_to_excel
} from "@/vendor/Export2Excel";
    export default {
        components: {
        },
        created() {
            this.getGameManagerList();
            this.sourceList();

        },

        data() {
            return {
              sourceData: [
                {
                  name:'全选',
                  source:''}
              ],
               totalList: [],
              sumTotals: [],
                tableData: [],
                queryParams:{
                  beginCreateTime: new Date(), //创建时间-开始
                  endCreateTime: new Date(),
                  source: "",
                },
                currentPage: 1,
                total: null,
                pageSize: 40,
                orderByDescColumn: "", // 降序字段
                orderByAscColumn: "", // 升序字段
            };
        },

        methods: {
          sourceList: function() {
            var sourceParams = {};
            sourceParams.pageSize = 1000;
            sourceParams.currentPage = 1;
            getSourceList(sourceParams).then(response => {
              this.sourceData.push(...response.data.records);
            });
          },
            getGameManagerList: function() {
                this.queryParams.currentPage = this.currentPage;
                this.queryParams.pageSize = this.pageSize;
                this.queryParams.orderByDescColumn = this.orderByDescColumn
                this.queryParams.orderByAscColumn = this.orderByAscColumn
              getAppReportList(this.queryParams).then(response => {
                    this.tableData = response.data.records;
                    this.currentPage = response.data.current;
                    this.pageSize = response.data.size;
                    this.total = response.data.total;
                });
              this.queryParams.currentPage = 1;
              this.queryParams.pageSize = -1;
              this.queryParams.orderByDescColumn = this.orderByDescColumn;
              this.queryParams.orderByAscColumn = this.orderByAscColumn;
              getAppReportList(this.queryParams).then(response => {
                this.sumTotals = response.data.records;
              });
            },


            changeSort (val) {
                // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
                if(val.order == "ascending") {
                    this.orderByAscColumn = val.prop
                    this.orderByDescColumn = ""
                } else {
                    this.orderByAscColumn = ""
                    this.orderByDescColumn = val.prop
                }
                this.getGameManagerList();
            },

            handleFind: function() {
                this.currentPage = 1
                this.getGameManagerList();
            },

            /**
             * 翻页事件
             */
            handleSizeChange(val) {
                this.pageSize = val;
                this.getGameManagerList();
            },
            //改变页码
            handleCurrentChange(val) {
                this.currentPage = val;
                this.getGameManagerList();
            },
          // 导出excel数据
          exportData() {
            // 表头对应关系
            const headers = {
              '日期': 'period',
              '渠道': 'sourceName',
              '日活(人)': 'onlineNum',
              '新用户(人)': 'registerNum',
              '全部订单总数（笔）': 'totalOrder',
              '成功订单总数（笔）': 'totalFinshOrder',
              '首存订单总数（笔）': 'totalFirstDep',
              '会员订单总数（笔）': 'totalVipOrder',
              '非会员订单总数（笔）': 'totalEtcOrder',
              '总存款用户数': 'totalDepNum',
              '成功存款用户数': 'depNum',
              '成功取款用户数': 'wdlNum',
              '首存订单总金额（元）': 'firstDepAmount',
              '成功订单总金额（元）': 'finshOrderAmount',
              '提现订单总金额（元）': 'wdlAmount',
              '提现订单总金额(已扣手续费)': 'wdlTaxAmount',
              '存取差（元）': 'depWdlSub',
            }
            this.queryParams.currentPage = 1;
            this.queryParams.pageSize = -1;
            this.queryParams.orderByDescColumn = this.orderByDescColumn
            this.queryParams.orderByAscColumn = this.orderByAscColumn
            getAppReportList(this.queryParams).then(response => {
              const records = response.data.records;
              if(this.totalList.length>0){
                const totalInfo = new Map();
                totalInfo.set("period",this.totalList[0]);
                totalInfo.set("source",this.totalList[1]);
                totalInfo.set("onlineNum",this.totalList[2]);
                totalInfo.set("registerNum",this.totalList[3]);
                totalInfo.set("totalOrder",this.totalList[4]);
                totalInfo.set("totalFinshOrder",this.totalList[5]);
                totalInfo.set("totalFirstDep",this.totalList[6]);
                totalInfo.set("totalVipOrder",this.totalList[7]);
                totalInfo.set("totalEtcOrder",this.totalList[8]);
                totalInfo.set("totalDepNum",this.totalList[9])
                totalInfo.set("depNum",this.totalList[10]);
                totalInfo.set("wdlNum",this.totalList[11]);
                totalInfo.set("firstDepAmount",this.totalList[12]);
                totalInfo.set("finshOrderAmount",this.totalList[13]);
                totalInfo.set("wdlAmount",this.totalList[14]);
                totalInfo.set("wdlTaxAmount",this.totalList[15]);
                totalInfo.set("depWdlSub",this.totalList[16]);
                records.push(this.mapToObj(totalInfo));
              }
              const data = this.formatJson(headers, response.data.records)
              export_json_to_excel(Object.keys(headers), data, '平台概括报表')
            });
          },
          // 该方法负责将数组转化成二维数组
          formatJson(headers, rows) {
              console.log(rows);
            // 首先遍历数组
            return rows.map(item => {
              return Object.keys(headers).map(key => {
                return item[headers[key]]
              })
            })
          },
          mapToObj(map){
              var obj = {};
              for(let [key,value] of map){
                obj[key] = value;
              }
              return obj;
          },
          getSummaries(param){
            this.totalList = [];
            param.data = this.sumTotals;
            const {columns,data} = param;
            const sums = [];
            columns.forEach((column,index)=> {
              if(index ===0){
                sums[index] = '总计';
                return;
              }
              if(index ===1){
                sums[index] = '';
                return;
              }
              const values = data.map(item => Number(item[column.property]));
              if(!values.every(value=> isNaN(value))){
                sums[index] = values.reduce((prev,curr)=>{
                   const value = Number(curr);
                   if(!isNaN(value)){
                     return prev +curr;
                   }else{
                     return prev;
                   }
                   sums[index] += '';
                },0)
              }else{
                sums[index] = 'N/A';
              }
            });
            this.totalList = sums;
            return sums;
          },

        }
    }
</script>
